//Contains the Mechaduino parameter declarations

#ifndef __PARAMETERS_H__
#define __PARAMETERS_H__


//----Current Parameters-----

extern volatile float Ts;
extern volatile float Fs;

extern volatile float pKp;
extern volatile float pKi;
extern volatile float pKd;

extern volatile float vKp;
extern volatile float vKi;
extern volatile float vKd;


//////////////////////////////////////
//////////////////PINS////////////////
//////////////////////////////////////
/*
extern const int IN_4;
extern const int IN_3;
extern const int VREF_2;
extern const int VREF_1;
extern const int IN_2;
extern const int IN_1;
extern const int pulse;
extern const int TEST1;
extern const int TEST2;
//extern const int ledPin;
extern const int chipSelectPin;

extern int step_pin;
extern int dir_pin;
*/
#define IN_4 	6
#define IN_3 	5
#define VREF_2 4
#define VREF_1 9
#define IN_2 	7
#define IN_1 	8
#define pulse 	13
#define chipSelectPin A2 //output to chip select

#define step_pin 1
#define dir_pin 0

#define IN1_HIGH() (REG_PORT_OUTSET0 = PORT_PA06)
#define IN1_LOW() (REG_PORT_OUTCLR0 = PORT_PA06)
#define IN2_HIGH() (REG_PORT_OUTSET0 = PORT_PA21)
#define IN2_LOW() (REG_PORT_OUTCLR0 = PORT_PA21)
#define IN3_HIGH() (REG_PORT_OUTSET0 = PORT_PA15)
#define IN3_LOW() (REG_PORT_OUTCLR0 = PORT_PA15)
#define IN4_HIGH() (REG_PORT_OUTSET0 = PORT_PA20)
#define IN4_LOW() (REG_PORT_OUTCLR0 = PORT_PA20)
#define PULSE_HIGH() (REG_PORT_OUTSET0 = PORT_PA17)
#define PULSE_LOW() (REG_PORT_OUTCLR0 = PORT_PA17)
#define CHIPSELECT_HIGH() (REG_PORT_OUTSET1 = PORT_PB09)
#define CHIPSELECT_LOW() (REG_PORT_OUTCLR1 = PORT_PB09)

#define ENABLE_PROFILE_IO		// Define to enable profiling I/O pins

#ifdef ENABLE_PROFILE_IO	
	#define TEST1 	2
	#define TEST2 	3

	#define TEST2_HIGH() (REG_PORT_OUTSET0 = PORT_PA09)
	#define TEST2_LOW() (REG_PORT_OUTCLR0 = PORT_PA09)
	#define TEST1_HIGH() (REG_PORT_OUTSET0 = PORT_PA14)
	#define TEST1_LOW() (REG_PORT_OUTCLR0 = PORT_PA14)
#else
	#define TEST2_HIGH()
	#define TEST2_LOW() 
	#define TEST1_HIGH()
	#define TEST1_LOW() 
#endif



//pins for debugging waveforms:
//extern int sine_out;				
//extern int encoder_out;


extern const int spr; //  200 steps per revolution
extern const float aps; // angle per step
extern int cpr; //counts per rev


extern int dir;		//initialize stepping mode variables
extern int step_state;


extern long angle; //holds processed angle value

extern float anglefloat;

//extern int a;  // raw encoder value in closed loop and print_angle routine (should fix the latter to include LUT)


extern volatile long step_count;  //For step/dir interrupt

extern volatile int interrupted;

extern int stepNumber; // step index for cal routine


extern const PROGMEM float sine_lookup[];
//extern const PROGMEM float lookup[];
extern const float lookup[];
extern const PROGMEM float force_lookup[];

#endif
